/**
 *
 * Distributed under the UTC Heudiascy Pacpus License, Version 1.0.
 * Copyright (c) UTC Heudiasyc 2010 - 2013. All rights reserved.
 *
 * See the LICENSE file for more information or a copy at:
 *   http://www.hds.utc.fr/~kurdejma/LICENSE_1_0.txt
 *
 */

#ifndef DEF_PACPUS_DBTPLYTRIGGER_H
#define DEF_PACPUS_DBTPLYTRIGGER_H

#include <QThread>

#include <Pacpus/DbitePlayer/DbitePlayerConfig.h>
#include <Pacpus/DbitePlayer/DbtPlyEngine.h>
#include <Pacpus/kernel/ComponentBase.h>
#include <Pacpus/kernel/ComponentFactory.h>

#ifdef WIN32
#   include <windows.h>
#   include <mmsystem.h>
#endif

namespace pacpus {

class DbtPlyEngine;

class DBITE_PLAYER_API DbtPlyTrigger
        : public QThread
        , public ComponentBase
{    
    Q_OBJECT

public:
    DbtPlyTrigger(QString name);
    virtual ~DbtPlyTrigger();

    virtual ComponentBase::COMPONENT_CONFIGURATION configureComponent(XmlComponentConfig config);

    virtual void run();

Q_SIGNALS:
    void triggerSig();

protected:
    virtual void startActivity();
    virtual void stopActivity();

private:
    DbtPlyEngine * mEngine;
};

} // namespace pacpus

#endif // DEF_PACPUS_DBTPLYTRIGGER_H
